
#include "stdafx.h"
#include "unitemovie.h"
#include "unitemovieDlg.h"
#include "commandline.h"	// R}hC
#include "FileDialogEx.h"	// gt@C_CAO
#include "DirDialog.h"		// fBNg_CAO
//#include "QTML.h"			// QuickTimeT|[g
//#include "CQuickTime.h"		// QuickTimeNXT|[g
#include "DlgTips.h"		// Tips_CAO
#include "Format.h"			// tH[}bg
//#include "Unzip.h"			// Zip𓀃T|[g
//#include <afxinet.h>		// C^[lbg֘A
//#include <afxtempl.h>		// ATL

//#include "hxcom.h"			// Helix COM
//#include "hxresult.h"		// Helix Result
//#include "crmedap.h"		// RMEditor
//#include "HelixInfo.h"		// Helix Information

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

///////////////////
// RXgN^
CUnitemovieDlg::CUnitemovieDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUnitemovieDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUnitemovieDlg)
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// _CAOʒu
	m_dlg_dir="";

	// exezuĂtH_pXi[
	char sPath[_MAX_PATH];
	char wkDrive[_MAX_DRIVE];
	char wkDir[_MAX_DIR];
	char wkFile[_MAX_FNAME];
	char wkExt[_MAX_EXT];
	GetModuleFileName(NULL,sPath,_MAX_PATH);
	_splitpath(sPath,wkDrive,wkDir,wkFile,wkExt);
	strcpy(m_AppDir,wkDrive);
	strcat(m_AppDir,wkDir);

	// etO
//	m_webable=FALSE;
}

/////////////////
// fXgN^
CUnitemovieDlg::~CUnitemovieDlg()
{
	// WXgɕۑi[
	AfxGetApp()->WriteProfileInt("save","type",m_save_type);
	AfxGetApp()->WriteProfileString("save","element",m_save_element.GetBuffer(m_save_element.GetLength()));

	AfxGetApp()->WriteProfileInt("save","height",m_height);
	AfxGetApp()->WriteProfileInt("save","width",m_width);
	AfxGetApp()->WriteProfileInt("save","top",m_top);
	AfxGetApp()->WriteProfileInt("save","left",m_left);

}

void CUnitemovieDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUnitemovieDlg)
	DDX_Control(pDX, IDC_STAT_MSG, m_stat_msg);
	DDX_Control(pDX, IDC_STAT_DUMMY, m_stat_dummy);
	DDX_Control(pDX, IDC_STAT_MAIN, m_stat_main);
	DDX_Control(pDX, IDOK, m_cmd_ok);
	DDX_Control(pDX, IDC_CMD_CLEAR2, m_cmd_clear2);
	DDX_Control(pDX, IDC_CMD_CLEAR, m_cmd_clear);
	DDX_Control(pDX, IDC_CMD_ADD, m_cmd_add);
	DDX_Control(pDX, IDC_CMD_SAVE, m_cmd_save);
	DDX_Control(pDX, IDC_LIST_SORT, m_lst_sort);
	DDX_Control(pDX, IDC_LIST_MAIN, m_lst_main);
	DDX_Control(pDX, IDC_EDIT_SAVE, m_edit_save);
	DDX_Control(pDX, IDC_CMD_UP, m_cmd_up);
	DDX_Control(pDX, IDC_CMD_DOWN, m_cmd_down);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUnitemovieDlg, CDialog)
	//{{AFX_MSG_MAP(CUnitemovieDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CMD_UP, OnCmdUp)
	ON_BN_CLICKED(IDC_CMD_DOWN, OnCmdDown)
	ON_WM_DROPFILES( )
	ON_BN_CLICKED(IDC_CMD_CLEAR, OnCmdClear)
	ON_BN_CLICKED(IDC_CMD_CLEAR2, OnCmdClear2)
	ON_COMMAND(ID_MENU_SAVE_DESKTOP, OnMenuSaveDesktop)
	ON_COMMAND(ID_MENU_SAVE_SAME, OnMenuSaveSame)
	ON_COMMAND(ID_MENU_SAVE_FIXED, OnMenuSaveFixed)
	ON_COMMAND(ID_MENU_SAVE_FILE, OnMenuSaveFile)
	ON_BN_CLICKED(IDC_CMD_ADD, OnCmdAdd)
	ON_WM_SIZE()
	ON_WM_CLOSE()

	ON_WM_DRAWITEM()

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//#include "bbmpeg\main.h"	// BBMPEGT|[g

/////////////////////////
// _CAO
BOOL CUnitemovieDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
	
	CCommandLine pCmd;		// R}hC
	CString sParam = "";	// R}hC
	CString sFlag = "";		// R}hCtO
	CString sItem="";		// XgACe

	/////////////////////////////////
	// R}hC
	/////////////////////////////////

	// R}hC
	BOOL bRet = pCmd.GetFirstParameter(sFlag, sParam);

	// XgɃt@Cꗗo
	while(bRet)
	{
		m_lst_sort.AddString(sParam);
		bRet = pCmd.GetNextParameter(sFlag, sParam);
	}
	for(int i=0;i<m_lst_sort.GetCount();i++){
		m_lst_sort.GetText(i,sItem);
		m_lst_main.AddString(sItem);
	}

	/////////////////////////////////
	// ۑݒWXgǍ
	/////////////////////////////////

	m_save_type=AfxGetApp()->GetProfileInt("save","type",1);
	m_save_element=AfxGetApp()->GetProfileString("save","element","");

	m_width=AfxGetApp()->GetProfileInt("save","width",492);
	m_height=AfxGetApp()->GetProfileInt("save","height",367);
	m_left=AfxGetApp()->GetProfileInt("save","left",-100);
	m_top=AfxGetApp()->GetProfileInt("save","top",-100);
//	m_show_tips=AfxGetApp()->GetProfileInt("save","showtips",TRUE);


	// _~[̐ݒ
	m_stat_dummy.SetWindowText("");m_stat_dummy.SetBkColor(COLORREF(STATUS_COLOR_BK));m_stat_dummy.SetTextColor(COLORREF(STATUS_COLOR_FORE));
	m_stat_msg.SetWindowText("");m_stat_msg.SetBkColor(COLORREF(STATUS_COLOR_BK));m_stat_msg.SetTextColor(COLORREF(STATUS_COLOR_FORE));
	m_stat_msg.SetWindowPos(&m_stat_dummy,0,0,0,0,SWP_NOMOVE);

	/////////////////////////////////
	// ̑̏
	/////////////////////////////////

	// ۑ{^̐ݒ
	m_cmd_save.SetMenuID(IDR_MENU_SAVE);
	m_cmd_save.SetMenuIndex(0);

	// EBhETCY𕜌
	CRect rcMain;
	GetWindowRect(rcMain);
	if(m_left>=0 && m_top>=0){
		rcMain.top=m_top;
		rcMain.left=m_left;
	}
	rcMain.right=rcMain.left+m_width;
	rcMain.bottom=rcMain.top+m_height;
	MoveWindow(rcMain);

	// N͉ʒɕ\
	if(m_left<0 && m_top<0)
		CenterWindow();

	// ۑ{^̐ݒ
	m_cmd_save.SetSelectedMenu(m_save_type);
	CalcPutName();

	// {^ACR̐ݒ
	m_cmd_up.SetIcon(AfxGetApp()->LoadIcon(IDI_UP));
	m_cmd_down.SetIcon(AfxGetApp()->LoadIcon(IDI_DOWN));

	// DROPꂽt@C󂯎悤ɂ
	DragAcceptFiles();

	// VXej[ǉ
	CMenu *pMenu = GetSystemMenu(NULL);


	// _CAO\
	RedrawWindow();
	ShowWindow(SW_SHOW);

/*	// TIPS\
	if(m_show_tips){
		CDlgTips MyDlg;
		MyDlg.DoModal();
	}
*/
	return TRUE;
}

////////////////////////////
// {^
void CUnitemovieDlg::OnOK() 
{
	CString sItem="";	// XgACe
	CString sMsg="";	// bZ[W

	// `FbN
	if(m_lst_main.GetCount()==0){
		AfxMessageBox("t@C܂B",MB_OK | MB_ICONINFORMATION);
		return;
	}

	// Xg擪̊gq擾
	m_lst_main.GetText(0,sItem);
	sItem=sItem.Right(sItem.GetLength()-sItem.ReverseFind('.')-1);
	sItem.MakeLower();

	// ӎvmF
	if(sItem=="avi" || sItem=="ogg" || sItem=="ogm")
		sMsg="Ă낵łH";
	else
		sMsg="gqavi,ogg,ogmł͂܂񂪎s܂H";
	if(AfxMessageBox(sMsg,MB_ICONQUESTION+MB_OKCANCEL)==IDCANCEL){
		return;
	}

	// s
	ControlFunc(sItem);
}

///////////////////////////////
// ďoRg[
void CUnitemovieDlg::ControlFunc(CString ipItem){
	CString sOut="";	// o͐
	BOOL ret;			// returnR[h

	if(ipItem=="aho"){
		if(AfxMessageBox("̂ف`",MB_ICONQUESTION+MB_OKCANCEL)==IDCANCEL){
				return;
			}
	}
	/////////////////////////////////
	// ʏ̃[r[t@C̏ꍇ
	/////////////////////////////////
	else{
		// o͐t@C̑݃`FbN(kt@C𓀎͕KvȂ)
		m_edit_save.GetWindowText(sOut);
		if(GetFileAttributes(sOut)!=0xFFFFFFFF){
			if(AfxMessageBox("ۑŎw肳ꂽt@C͊ɑ݂܂B㏑܂H",MB_ICONQUESTION+MB_OKCANCEL)==IDCANCEL){
				return;
			}
		}

		// Jn
		OnUniteStart();
		PrintMsg("JnĂ܂c");

		// e{(G[̃bZ[W͊e֐ŕ\)

			ret=UniteAvi();
		
		// Ɋꍇ͌㏈s
		if(ret){
			// t@C̍폜
//			if(DeleteBaseFiles()){
				// bZ[W
				PrintMsg("܂B");
				AfxMessageBox("܂B",MB_OK | MB_ICONINFORMATION);
				// Xg̃NA
//				if(m_clear)OnCmdClear();
//			}
		}

		// I
		OnUniteEnd();
	}
}

/////////////////////////
// Jn̏
void CUnitemovieDlg::OnUniteStart(){

	BeginWaitCursor();

}

/////////////////////////
// Ȉ
void CUnitemovieDlg::OnUniteEnd(){


	EndWaitCursor();
}

/////////////////////////
// bZ[Wo͏
void CUnitemovieDlg::PrintMsg(LPCTSTR ipMsg){
	m_stat_msg.SetWindowText(ipMsg);
	m_stat_msg.RedrawWindow();
}

///////////////////////
// Xebvo
void CUnitemovieDlg::PrintStepMsg(int* ipNow,int ipAll,LPCTSTR ipMsg){
	char sBuff[200];	// lobt@
	CString sMsg="";	// o̓bZ[W

	// Xebv
	sprintf(sBuff,"%d/%d",*ipNow,ipAll);

	// o̓bZ[W쐬
	sMsg=sBuff;
	sMsg+="ï ";
	sMsg+=ipMsg;
	(*ipNow)++;

	// bZ[Wo
	PrintMsg(sMsg);
}


/////////////////////////////////
// pXt@Ĉ݂Ԃ
CString CUnitemovieDlg::FileFromPath(LPCTSTR ipPath){
	char wkDrive[_MAX_DRIVE];	// pXp
	char wkDir[_MAX_DIR];		// pXp
	char wkFile[_MAX_FNAME];	// pXp
	char wkExt[_MAX_EXT];		// pXp
	CString sFile="";			// t@C

	// pX
	_splitpath(ipPath,wkDrive,wkDir,wkFile,wkExt);

	// t@Ci[
	sFile=wkFile;
	sFile+=wkExt;

	return sFile;
}

////////////////////////
// Avit@C
BOOL CUnitemovieDlg::UniteAvi(){
	char sJobPath[_MAX_PATH];	// [pX] Jobt@C
	char sVDPath[_MAX_PATH];	// [pX] VirtualDub.exe
	CString sMsg="";			// bZ[W
	CString sItem="";			// ACe
	CString sJob="";			// Wu
	CString sPathWrite="";		// pX()
	CString sCmdLine="";		// R}hC
	CFile fWrite;				// t@C()
//	STARTUPINFO st_start;		// CreateProcessp
//	PROCESS_INFORMATION st_info;// CreateProcessp


	// OGMerger̃pX擾
	strcpy(sVDPath,m_AppDir);
	strcat(sVDPath,"OGMerger.exe");

	// ݃`FbN
	if(GetFileAttributes(sVDPath)==0xFFFFFFFF){
		AfxMessageBox("OGMerger.exe܂B",MB_ICONSTOP+MB_OK);
		return FALSE;
	}

	// Jobt@C쐬
	strcpy(sJobPath,m_AppDir);
	strcat(sJobPath,"work.job");
	if(!fWrite.Open(sJobPath,CFile::modeCreate|CFile::modeWrite)){
		sMsg="Wut@Cu";
		sMsg+=sJobPath;
		sMsg+="v쐬邱Ƃo܂łB";
		AfxMessageBox(sMsg,MB_ICONSTOP+MB_OK);
		return FALSE;
	}

	// Wut@C쐬
	m_edit_save.GetWindowText(sPathWrite);
	for(int i=0;i<m_lst_main.GetCount();i++){
		m_lst_main.GetText(i,sItem);
//		sItem.Replace("\\","\\\\");
		if(i==0){
			sJob += "ogmerger -o ";
			sJob += sPathWrite;
			sJob += " ";
			sJob += sItem;
		}
		else{
			sJob += " ";
			sJob += sItem;
		}
	}



char *pexe = new char[sJob.GetLength()+1];
strcpy( pexe, sJob );

STARTUPINFO si;
    PROCESS_INFORMATION pi;

    ZeroMemory(&si, sizeof(si));
    ZeroMemory(&pi, sizeof(pi));
    si.cb = sizeof(si);

    CreateProcess(NULL, pexe, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);

WaitForSingleObject(pi.hProcess, INFINITE);
    CloseHandle(pi.hThread);
    CloseHandle(pi.hProcess);


	HANDLE hFile;
	hFile = CreateFile(
		sPathWrite,
		0,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		NULL);

	// bZ[W\ o̓t@CȂ̓TCY0Ȃ玸s
	sPathWrite.Replace("\\\\","\\");
	if(GetFileAttributes(sPathWrite)==0xFFFFFFFF || 1024 > GetFileSize( hFile , NULL )){
		AfxMessageBox("Ɏs܂B\nOGM`̃t@Cł邩@KvȃR[fbNCXg[Ă邩mFĂB",MB_ICONSTOP+MB_OK);
		CloseHandle( hFile );
		return FALSE;
	}

	return TRUE;
}



/////////////////
// pX擾
BOOL CUnitemovieDlg::GetSpecialFolderPath( HWND hWnd, int nFolder, char *Path )
{
	IMalloc    *pMalloc;
	ITEMIDLIST *pidl;
	
	if ( NOERROR == SHGetMalloc( &pMalloc ) )
	{
		if ( NOERROR == SHGetSpecialFolderLocation( hWnd, nFolder, &pidl ) )
		{
			if ( SHGetPathFromIDList( pidl, Path ) )
			{
				pMalloc->Free( pidl );
				pMalloc->Release();
				return TRUE;
			}
			pMalloc->Free( pidl );
		}
		pMalloc->Release();
	}
	return FALSE;
}

/////////////
// `揈
void CUnitemovieDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

////////////////////
// OnQueryDragIcon
HCURSOR CUnitemovieDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////
// DROP
void CUnitemovieDlg::OnDropFiles(HDROP hDropInfo){
	int i,iLen,iCnt;
	char sName[_MAX_PATH];
	bool bFirst;
	CString sItem="";

	bFirst=(m_lst_main.GetCount()==0);

	// DROPꂽt@C̎擾
	iCnt = DragQueryFile(hDropInfo, -1, NULL,0);

	// DROPꂽt@CXgɒǉ
	m_lst_sort.ResetContent();
	for(i=0; i<iCnt; i++) {
		iLen = DragQueryFile(hDropInfo, i, NULL,0);
		DragQueryFile(hDropInfo, i, sName, _MAX_PATH);
		m_lst_sort.AddString(sName);
	}
	DragFinish(hDropInfo);

	for(i=0;i<m_lst_sort.GetCount();i++){
		m_lst_sort.GetText(i,sItem);
		m_lst_main.AddString(sItem);
	}

	// o̓t@CZo
	if(bFirst) CalcPutName();
}

//////////////////////
// t@Cǉ
void CUnitemovieDlg::OnCmdAdd()
{
	bool bFirst;				// 擪tO
	CString sItem="";			// ACe
	POSITION pos;				// It@Cʒu
	char sDir[_MAX_PATH];		// fBNg
	int i;						// JE^
	char wkDrive[_MAX_DRIVE];	// pXp
	char wkDir[_MAX_DIR];		// pXp
	char wkFile[_MAX_FNAME];	// pXp
	char wkExt[_MAX_EXT];		// pXp

	// _CAOʒuȂݒ
	if(m_dlg_dir==""){
		// fXNgbv or t@CƓʒȕꍇ
		// ʒufXNgbvɐݒ
		if(m_save_type==0 || m_save_type==1){
			GetSpecialFolderPath(0,CSIDL_DESKTOPDIRECTORY,sDir);
			m_dlg_dir=sDir;
		}
		// ̃tH_̏ꍇ͏ʒu
		// ̃tH_ɐݒ
		else if(m_save_type==2){
			m_dlg_dir=m_save_element;
		}
	}

	// _CAOʒuݒ(JgfBNg)
	::SetCurrentDirectory(m_dlg_dir);

	// I_CAOݒ
	CFileDialogEx fdOpen(
		TRUE,						// t@CJ
		NULL,						// ftHggq
		NULL,						// \t@C
		OFN_FILEMUSTEXIST |
		OFN_HIDEREADONLY |			// ǎp`FbN{bNX͕\Ȃ
		OFN_ALLOWMULTISELECT, 		// I
		"");						// gqXg
	fdOpen.m_ofn.lpstrTitle="t@CIĉ";
	fdOpen.m_ofn.lpstrFilter = "OGM̧(ogm,avi,ogg)\0*.ogg;*.ogm;*.avi\0SĂ̧(*.*)\0*\0\0";

	// I_CAO\
	BeginWaitCursor();
	if(fdOpen.DoModal()==IDCANCEL){
		EndWaitCursor();
		return;
	}
	EndWaitCursor();

	// 擪(擪Ȃ炠Ƃŏo̓t@CZos)
	bFirst=(m_lst_main.GetCount()==0);

	// DROPꂽt@C\[gXgɒǉ
	m_lst_sort.ResetContent();
	pos = fdOpen.GetStartPosition();
	i=0;
	while(pos){
		// Xgɒǉ
		sItem = fdOpen.GetNextPathName(pos);
		m_lst_sort.AddString(sItem);
		i++;
		// 擪Ȃ_CAOʒuݒ肷
		if(i==1){
			_splitpath(sItem.GetBuffer(sItem.GetLength()),wkDrive,wkDir,wkFile,wkExt);
			m_dlg_dir=wkDrive;
			m_dlg_dir+=wkDir;
		}
	}
	// DROPꂽt@CXgɒǉ
	for(i=0;i<m_lst_sort.GetCount();i++){
		m_lst_sort.GetText(i,sItem);
		m_lst_main.AddString(sItem);
	}

	// o̓t@CZo
	if(bFirst) CalcPutName();
}

///////////////////
// Xg̃NA
void CUnitemovieDlg::OnCmdClear() 
{
	m_lst_main.ResetContent();
	m_edit_save.SetWindowText("");
	m_edit_save.EnableWindow();
	m_cmd_ok.SetWindowText("");
}

///////////////////
// ACe̍폜
void CUnitemovieDlg::OnCmdClear2() 
{
	int iIndex;			// 폜̑Iʒu
	int iMax;			// Xg
	CString sTop="";	// 擪ACe
	CString sItem="";	// ACe

	// I`FbN
	if(m_lst_main.GetSelCount()==0){
//		AfxMessageBox("Xg̃ACeIĉB",MB_OK | MB_ICONINFORMATION);
		return;
	}

	// 擪ACe擾
	m_lst_main.GetText(0,sTop);

	// IĂACe폜
	iMax=m_lst_main.GetCount();
	for(int i=0;i<iMax;i++){
		if(m_lst_main.GetSel(i)){
			m_lst_main.DeleteString(i);
			iIndex=i;
			i--;
			iMax--;
		}
	}

	// 폜̑I
	if(iIndex==m_lst_main.GetCount())iIndex--;
	m_lst_main.SetSel(iIndex);

	// 擪ACeςꍇ͏o̓t@CZo
	if(m_lst_main.GetCount()!=0){
		m_lst_main.GetText(0,sItem);
		if(sItem!=sTop) CalcPutName();
	}
}

/////////////
// {^
void CUnitemovieDlg::OnCmdUp() 
{
	CString sTop="";	// 擪ACe
	CString sItem="";	// XgACe
	int iIndex;			// XgCfbNX

	// ACe݃`FbN
	if(m_lst_main.GetCount()==0){
//		AfxMessageBox("ACe܂B",MB_OK | MB_ICONINFORMATION);
		return;
	}

	// tH[JXACëʒu擾
	iIndex = m_lst_main.GetCurSel();

	// `FbN
	if(m_lst_main.GetSelCount()==0){
		AfxMessageBox("Xg̃ACeIĉB",MB_OK | MB_ICONINFORMATION);
		return;
	}
	if(iIndex==0){
//		AfxMessageBox("擪̃ACeグ邱Ƃ͏o܂B",MB_OK | MB_ICONINFORMATION);
		return;
	}

	// 擪ACe擾
	m_lst_main.GetText(0,sTop);

	// tH[JXACeȊO͑I
	for(int i=0;i<m_lst_main.GetCount();i++){
		if(m_lst_main.GetSel(i)){
			if(i!=iIndex){
				m_lst_main.SetSel(i,FALSE);
			}
		}
	}

	// ֈړ
	m_lst_main.GetText(iIndex,sItem);
	m_lst_main.DeleteString(iIndex);
	m_lst_main.InsertString(iIndex-1,sItem);
	m_lst_main.SetSel(iIndex-1);

	// 擪ACeςꍇ͏o̓t@CZo
	m_lst_main.GetText(0,sItem);
	if(sItem!=sTop) CalcPutName();
}

/////////////
// {^
void CUnitemovieDlg::OnCmdDown() 
{
	CString sTop="";	// 擪ACe
	CString sItem="";	// XgACe
	int iIndex;			// XgCfbNX

	// ACe݃`FbN
	if(m_lst_main.GetCount()==0){
//		AfxMessageBox("ACe܂B",MB_OK | MB_ICONINFORMATION);
		return;
	}

	// tH[JXACe擾
	iIndex = m_lst_main.GetCurSel();

	// `FbN
	if(m_lst_main.GetSelCount()==0){
		AfxMessageBox("Xg̃ACeIĉB",MB_OK | MB_ICONINFORMATION);
		return;
	}
	if(iIndex==m_lst_main.GetCount()-1){
//		AfxMessageBox("̃ACe邱Ƃ͏o܂B",MB_OK | MB_ICONINFORMATION);
		return;
	}

	// 擪ACe擾
	m_lst_main.GetText(0,sTop);

	// tH[JXACeȊO͑I
	for(int i=0;i<m_lst_main.GetCount();i++){
		if(m_lst_main.GetSel(i)){
			if(i!=iIndex){
				m_lst_main.SetSel(i,FALSE);
			}
		}
	}

	// ֈړ
	m_lst_main.GetText(iIndex,sItem);
	m_lst_main.DeleteString(iIndex);
	m_lst_main.InsertString(iIndex+1,sItem);
	m_lst_main.SetSel(iIndex+1);

	// 擪ACeςꍇ͏o̓t@CZo
	m_lst_main.GetText(0,sItem);
	if(sItem!=sTop) CalcPutName();
}

///////////////////////
// fXNgbvɕۑ
void CUnitemovieDlg::OnMenuSaveDesktop() 
{
	m_save_type=0;
	m_save_element="";
	m_cmd_save.SetSelectedMenu(m_save_type);
	CalcPutName();
}

///////////////////////////////
// t@CƓꏊɕۑ
void CUnitemovieDlg::OnMenuSaveSame()
{
	m_save_type=1;
	m_save_element="";
	m_cmd_save.SetSelectedMenu(m_save_type);
	CalcPutName();
}

///////////////////////
// ŒtH_ɕۑ
void CUnitemovieDlg::OnMenuSaveFixed() 
{
	CDirDialog MyDlg;// fBNg_CAO

	// fBNg_CAO\
	MyDlg.m_hParent=m_hWnd;
	MyDlg.m_strTitle="ۑtH_Iĉ";
	BeginWaitCursor();
	if(!MyDlg.DoBrowse()){
		EndWaitCursor();
		return;
	}
	EndWaitCursor();

	// ݒ𔽉f
	m_save_type=2;
	m_save_element=MyDlg.m_strPath;
	if(m_save_element.Right(1)!="\\")
		m_save_element+="\\";
	m_cmd_save.SetSelectedMenu(m_save_type);
	CalcPutName();
}

///////////////////
// t@CQ
void CUnitemovieDlg::OnMenuSaveFile() 
{
	CFileDialogEx fdSave(
		FALSE,						// t@Cۑ
		NULL,						// ftHggq
		NULL,						// \t@C
		OFN_HIDEREADONLY |			// ǎp`FbN{bNX͕\Ȃ
		OFN_OVERWRITEPROMPT, 		// Ƀt@C݂Ăꍇ㏑mF\
		"SĂ̧(*.*)|*.*||");	// gqXg
	fdSave.m_ofn.lpstrTitle="t@C̕ۑw肵ĉ";

	// I_CAO\
	BeginWaitCursor();
	if(fdSave.DoModal()==IDCANCEL){
		EndWaitCursor();
		return;
	}
	EndWaitCursor();

	// ݒ𔽉f
	m_save_type=3;
	m_save_element=fdSave.m_ofn.lpstrFile;
	m_cmd_save.SetSelectedMenu(m_save_type);
	CalcPutName();
}

///////////////////////
// o̓t@CZo
void CUnitemovieDlg::CalcPutName(){
	CFormat ff;					// tH[}bg
	CFile fRead;				// t@C
	CString sItem="";			// XgACe
	CString sFile="";			// t@C
	CString sFull="";			// tpX
	char sDir[_MAX_PATH];		// ۑfBNg
	char wkDrive[_MAX_DRIVE];	// [[N] hCu
	char wkDir[_MAX_DIR];		// [[N] fBNg
	char wkFile[_MAX_FNAME];	// [[N] t@C
	char wkExt[_MAX_EXT];		// [[N] gq
	char sPut[100];				// Aԗpobt@
	char sBuff[1024];			// obt@
	char sExtBuff[_MAX_PATH];	// gqobt@
	long lRead;					// ǂݍݍς
	int i=0;					// JE^

	// t@Cw̏ꍇ̂܂ܕ\
	if(m_save_type==3){
		m_edit_save.SetWindowText(m_save_element);
		return;
	}

	// Xg1΃t@C͕\Ȃ
	if(m_lst_main.GetCount()==0){
		m_edit_save.SetWindowText("");
		return;
	}

	// Xg̐擪ACe擾
	m_lst_main.GetText(0,sItem);
	_splitpath(sItem.GetBuffer(sItem.GetLength()),wkDrive,wkDir,wkFile,wkExt);

	// o͐fBNgZo
	switch(m_save_type){
	case 0:	// fXNgbv
		GetSpecialFolderPath(0,CSIDL_DESKTOPDIRECTORY,sDir);
		strcat(sDir,"\\");
		break;
	case 1:	// t@CƓtH_
		strcpy(sDir,wkDrive);
		strcat(sDir,wkDir);
		break;
	case 2:	// ŒtH_
		strcpy(sDir,m_save_element.GetBuffer(m_save_element.GetLength()));
		break;
	default:
		GetSpecialFolderPath(0,CSIDL_DESKTOPDIRECTORY,sDir);
		break;
	}

	// o̓t@CZo
	sFile=wkFile;
	sFile.Replace("0","");
	sFile.Replace("1","");
	sFile.Replace("2","");
	sFile.Replace("3","");
	sFile.Replace("4","");
	sFile.Replace("5","");
	sFile.Replace("6","");
	sFile.Replace("7","");
	sFile.Replace("8","");
	sFile.Replace("9","");
	sFile.Replace("10","");
	sFile.Replace("-","");
	sFile.Replace("_","");

	// t@CɂȂꍇ́uunitedvƂOɂ
	if(sFile=="")
		sFile="united";
	
	// t@CƓtH_AAOꍇ
	// t@Cɏ㏑Ă܂̂ŁAt@CɁu-unitedvǉ
	if(m_save_type==1 && strcmp(sFile.GetBuffer(sFile.GetLength()),wkFile)==0)
		sFile+="-united";

	// gqm̏ꍇ̓wb_琄
	if(strcmp(wkExt,".rm")!=0 && strcmp(wkExt,".ram")!=0 && strcmp(wkExt,".ra")!=0 &&
		strcmp(wkExt,".mpg")!=0 && strcmp(wkExt,".mpeg")!=0 && strcmp(wkExt,".mpa")!=0 &&
		strcmp(wkExt,".asf")!=0 && strcmp(wkExt,".wmv")!=0 && strcmp(wkExt,".avi")!=0 &&
		strcmp(wkExt,".mov")!=0 && strcmp(wkExt,".qt")!=0){
		if(fRead.Open(sItem,CFile::modeRead)){
			TRY{
				lRead = fRead.Read(sBuff,100);
				if(lRead>=0){
					strcpy(sExtBuff,ff.Analyze((unsigned char*)sBuff,lRead));
					if(strcmp(sExtBuff,"")!=0){
						strcpy(wkExt,".");
						strcat(wkExt,sExtBuff);
					}
				}
			}
			CATCH(CFileException,e){
			}
			END_CATCH
			fRead.Close();
		}
	}

	// tpX쐬
	sFull=sDir;
	sFull+=sFile;
	sFull+=wkExt;

	// ̃t@Cꍇ͘AԂU
	while(1){
		if(GetFileAttributes(sFull)==0xFFFFFFFF)break;
		i++;
		sprintf(sPut,"-%d",i);
		sFull=sDir;
		sFull+=sFile;
		sFull+=sPut;
		sFull+=wkExt;
	}

	// \
	m_edit_save.SetWindowText(sFull);

/*	// rezt@C̏ꍇ̓eLXg{bNX𗘗psɂ
	strupr(wkExt);
	BOOL bEnable;
	bEnable=(strcmp(wkExt,".REZ")!=0 && strcmp(wkExt,".ZIP")!=0);
	m_edit_save.EnableWindow(bEnable);

	// kt@C̏ꍇ̓{^̃LvVς
	if(strcmp(wkExt,".ZIP")!=0) m_cmd_ok.SetWindowText("");
	else						m_cmd_ok.SetWindowText("");
*/}





///////////////////////////
// bZ[WnhO
BOOL CUnitemovieDlg::PreTranslateMessage(MSG* pMsg) 
{
	// VXej[̃bZ[WM
/*	if(pMsg->message==WM_SYSCOMMAND){
		if(pMsg->wParam==ID_MENU_SYSTEM_FORE){
			OnMenuSystemFore();
		}
		else if(pMsg->wParam==ID_MENU_SYSTEM_DELETE){
			OnMenuSystemDelete();
		}
		else if(pMsg->wParam==ID_MENU_SYSTEM_CLEAR){
			OnMenuSystemClear();
		}
		else if(pMsg->wParam==ID_MENU_SYSTEM_ADV){
			OnMenuSystemAdv();
		}
		else if(pMsg->wParam==ID_MENU_SYSTEM_SEND){
			OnMenuSystemSend();
		}
		else if(pMsg->wParam==ID_MENU_SYSTEM_WEB){
			OnMenuSystemWeb();
		}
		else if(pMsg->wParam==ID_MENU_SYSTEM_AUTO){
			OnMenuSystemAuto();
		}
	}
*/	return CDialog::PreTranslateMessage(pMsg);
}

///////////////
// TCYύX
void CUnitemovieDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	AdjustComponent();
}

/////////////////////////
// Rg[ʒu
void CUnitemovieDlg::AdjustComponent(){
	const C_ADV_HEIGHT=20;
	CRect rcMain;	// _CAOʒu
	CRect rcTab;	// ^uʒu
	CRect rcWork;	// [Nʒu

	// L`FbN
	if(IsIconic() || !IsWindow(m_lst_main.m_hWnd))
		return;

	// _CAOʒu擾
	GetWindowRect(rcMain);

	// VXëO
	rcMain.top		= rcMain.top	+GetSystemMetrics(SM_CYCAPTION)	+GetSystemMetrics(SM_CYSIZEFRAME);
	rcMain.left		= rcMain.left	+GetSystemMetrics(SM_CXSIZEFRAME);

	// OK{^
	m_cmd_ok.GetWindowRect(rcWork);
	rcWork.OffsetRect(-rcMain.left,-rcMain.top);
	rcWork.bottom = rcMain.Height() -15-C_ADV_HEIGHT;
	rcWork.top = rcWork.bottom -21;
	rcWork.right = rcMain.Width() - 15;
	rcWork.left = rcWork.right - 61;
	m_cmd_ok.MoveWindow(CRect(rcWork.left,rcWork.top,rcWork.right,rcWork.bottom));

	// ۑeLXg
	m_edit_save.GetWindowRect(rcWork);
	rcWork.OffsetRect(-rcMain.left,-rcMain.top);
	rcWork.bottom = rcMain.Height() -15-C_ADV_HEIGHT;
	rcWork.top = rcWork.bottom -21;
	rcWork.right = rcMain.Width() - 88;
	m_edit_save.MoveWindow(CRect(rcWork.left,rcWork.top,rcWork.right,rcWork.bottom));

	// ۑ{^
	m_cmd_save.GetWindowRect(rcWork);
	rcWork.OffsetRect(-rcMain.left,-rcMain.top);
	rcWork.bottom = rcMain.Height() -14-C_ADV_HEIGHT;
	rcWork.top = rcWork.bottom -22;
	m_cmd_save.MoveWindow(CRect(rcWork.left,rcWork.top,rcWork.right,rcWork.bottom));

	// t@CXg
	m_lst_main.GetWindowRect(rcWork);
	rcWork.OffsetRect(-rcMain.left,-rcMain.top);
	rcWork.bottom = rcMain.Height() -43-C_ADV_HEIGHT;
	rcWork.right = rcMain.Width() - 15;
	m_lst_main.MoveWindow(CRect(rcWork.left,rcWork.top,rcWork.right,rcWork.bottom));


	// {^
	m_cmd_down.GetWindowRect(rcWork);
	rcWork.OffsetRect(-rcMain.left,-rcMain.top);
	rcWork.right = rcMain.Width() - 15;
	rcWork.left = rcWork.right - 40;
	m_cmd_down.MoveWindow(CRect(rcWork.left,rcWork.top,rcWork.right,rcWork.bottom));

	// {^
	rcWork.right = rcWork.left - 2;
	rcWork.left = rcWork.right - 40;
	m_cmd_up.MoveWindow(CRect(rcWork.left,rcWork.top,rcWork.right,rcWork.bottom));

	// ǉ{^
	rcWork.right = rcWork.left - 8;
	rcWork.left = rcWork.right - 42;
	m_cmd_add.MoveWindow(CRect(rcWork.left,rcWork.top,rcWork.right,rcWork.bottom));

	// O{^
	rcWork.right = rcWork.left - 3;
	rcWork.left = rcWork.right - 42;
	m_cmd_clear2.MoveWindow(CRect(rcWork.left,rcWork.top,rcWork.right,rcWork.bottom));

	// NA{^
	rcWork.right = rcWork.left - 3;
	rcWork.left = rcWork.right - 42;
	m_cmd_clear.MoveWindow(CRect(rcWork.left,rcWork.top,rcWork.right,rcWork.bottom));

	// Xgx
	m_stat_main.GetWindowRect(rcWork);
	rcWork.OffsetRect(-rcMain.left,-rcMain.top);
	rcWork.right = rcMain.Width()-240;
	m_stat_main.MoveWindow(CRect(rcWork.left,rcWork.top,rcWork.right,rcWork.bottom));

	// ĕ`
	m_cmd_ok.RedrawWindow();
	m_edit_save.RedrawWindow();
	m_cmd_save.RedrawWindow();
	m_lst_main.RedrawWindow();
	m_cmd_down.RedrawWindow();
	m_cmd_up.RedrawWindow();
	m_cmd_add.RedrawWindow();
	m_cmd_clear2.RedrawWindow();
	m_cmd_clear.RedrawWindow();
	m_stat_main.RedrawWindow();

}

///////////////
// I
void CUnitemovieDlg::OnClose() 
{
	WINDOWPLACEMENT wp;

	// EBhËʒuL^
	GetWindowPlacement(&wp);
	
	// EBhËʒuL^
	m_left=wp.rcNormalPosition.left;
	m_top=wp.rcNormalPosition.top;

	// EBhȆ傫L^
	m_width= wp.rcNormalPosition.right - wp.rcNormalPosition.left;
	m_height=wp.rcNormalPosition.bottom - wp.rcNormalPosition.top;

	CDialog::OnClose();
}

